// Ancova (fixed effects)
DATA_SECTION
  init_int k
  init_int n
  init_vector x(1,n)
  init_matrix y(1,k,1,n)

PARAMETER_SECTION
  init_vector beta0(1,k)
  init_number beta1
  init_number logSigma
  sdreport_number sigma
  matrix yfit(1,k,1,n)
  number RSS
  objective_function_value f

PROCEDURE_SECTION
  for(int i=1; i<=k; i++)
    for(int j=1; j<=n; j++)
      yfit(i,j) = beta0(i) + beta1*x(j);
  sigma = mfexp(logSigma);
  RSS = sum(square(y-yfit));
  f = 0.5*k*n*log(2.0*M_PI) + k*n*logSigma + RSS/(2.0*square(sigma));

REPORT_SECTION
  report << "# f"     << endl << f     << endl << endl;
  report << "# beta0" << endl << beta0 << endl << endl;
  report << "# beta1" << endl << beta1 << endl << endl;
  report << "# sigma" << endl << sigma << endl << endl;
  report << "# x"     << endl << x     << endl << endl;
  report << "# y"     << endl << y     << endl << endl;
  report << "# yfit"  << endl << yfit  << endl << endl;
