DATA_SECTION
  init_int M
  init_int n
  init_vector x(1,n)
  init_matrix y(1,M,1,n)

PARAMETER_SECTION
  init_vector phi1(1,M)
  init_number phi2
  init_number phi3
  init_number logSigma
  sdreport_number sigma
  matrix yfit(1,M,1,n)
  number RSS
  objective_function_value f

PROCEDURE_SECTION
  sigma = exp(logSigma);
  for (int i=1; i<=M; i++)
  {
    for (int j=1; j<=n; j++)
    {
      yfit(i,j) = phi1(i) / (1.0 + exp(-(x(j)-phi2)/phi3));
    }
  }
  RSS = sum(square(y-yfit));
  f = 0.5*M*n*log(2.0*M_PI) + M*n*logSigma + RSS/(2.0*square(sigma));

REPORT_SECTION
  report << yfit;
