DATA_SECTION
  init_int M
  init_int n
  init_vector x(1,n)
  init_matrix y(1,M,1,n)

PARAMETER_SECTION
  init_number phi1
  init_number phi2
  init_number phi3
  init_number logSigma
  init_number logSigmaB(3)        // estimated in phase 3
  random_effects_vector b(1,M,2)  // estimated in phase 2
  sdreport_number sigma
  sdreport_number sigmaB
  matrix yfit(1,M,1,n)
  number RSS
  objective_function_value f

PROCEDURE_SECTION
  sigma = exp(logSigma);
  sigmaB = exp(logSigmaB);
  for (int i=1; i<=M; i++)
  {
    for (int j=1; j<=n; j++)
    {
      yfit(i,j) = (phi1 + b(i)) / (1.0 + exp(-(x(j)-phi2)/phi3));
    }
  }
  RSS = sum(square(y-yfit));
  f = 0.5*M*n*log(2.0*M_PI) + M*n*logSigma + RSS/(2.0*square(sigma));
  f += 0.5*M*log(2.0*M_PI) + M*logSigmaB + sum(square(b))/(2.0*square(sigmaB));

REPORT_SECTION
  report << yfit;
